GEOS: geos::geom::LineSegment Class Reference

Public Member Functions | Public Attributes | Friends

# geos::geom::LineSegment Class Reference

`#include <LineSegment.h>`

Inheritance diagram for geos::geom::LineSegment:

List of all members.

## Public Member Functions
| LineSegment ()
| Segemnt end.
| LineSegment (const LineSegment &ls)
| LineSegment (const Coordinate &c0, const Coordinate &c1)
| Constructs a LineSegment with the given start and end Coordinates.
| LineSegment (double x0, double y0, double x1, double y1)
void | setCoordinates (const Coordinate &c0, const Coordinate &c1)
const Coordinate & | operator[] (size_t i) const
Coordinate & | operator[] (size_t i)
void | setCoordinates (const LineSegment &ls)
double | getLength () const
| Computes the length of the line segment.
bool | isHorizontal () const
| Tests whether the segment is horizontal.
bool | isVertical () const
| Tests whether the segment is vertical.
int | orientationIndex (const LineSegment &seg) const
int | orientationIndex (const LineSegment *seg) const
int | orientationIndex (const Coordinate &p) const
| Determines the orientation index of a Coordinate relative to this segment.
void | reverse ()
| Reverses the direction of the line segment.
void | normalize ()
| Puts the line segment into a normalized form.
double | angle () const
void | midPoint (Coordinate &ret) const
| Computes the midpoint of the segment.
double | distance (const LineSegment &ls) const
| Computes the distance between this line segment and another one.
double | distance (const Coordinate &p) const
| Computes the distance between this line segment and a point.
double | distancePerpendicular (const Coordinate &p) const
| Computes the perpendicular distance between the (infinite) line defined by this line segment and a point.
void | pointAlong (double segmentLengthFraction, Coordinate &ret) const
| Computes the Coordinate that lies a given fraction along the line defined by this segment.
void | pointAlongOffset (double segmentLengthFraction, double offsetDistance, Coordinate &ret) const
| Computes the Coordinate that lies a given fraction along the line defined by this segment and offset from the segment by a given distance.
double | projectionFactor (const Coordinate &p) const
| Compute the projection factor for the projection of the point p onto this LineSegment.
double | segmentFraction (const Coordinate &inputPt) const
| Computes the fraction of distance (in `[0.0, 1.0]`) that the projection of a point occurs along this line segment.
void | project (const Coordinate &p, Coordinate &ret) const
| Compute the projection of a point onto the line determined by this line segment.
bool | project (const LineSegment &seg, LineSegment &ret) const
| Project a line segment onto this line segment and return the resulting line segment.
void | closestPoint (const Coordinate &p, Coordinate &ret) const
| Computes the closest point on this line segment to another point.
int | compareTo (const LineSegment &other) const
| Compares this object with the specified object for order.
bool | equalsTopo (const LineSegment &other) const
| Returns `true` if `other` is topologically equal to this LineSegment (e.g. irrespective of orientation).
CoordinateSequence * | closestPoints (const LineSegment &line)
CoordinateSequence * | closestPoints (const LineSegment *line)
bool | intersection (const LineSegment &line, Coordinate &coord) const
bool | lineIntersection (const LineSegment &line, Coordinate &coord) const
| Computes the intersection point of the lines defined by two segments, if there is one.
std::auto_ptr< LineString > | toGeometry (const GeometryFactory &gf) const
## Public Attributes
Coordinate | p0
Coordinate | p1
| Segment start.
## Friends
std::ostream & | operator<< (std::ostream &o, const LineSegment &l)

## Detailed Description

Represents a line segment defined by two Coordinate. Provides methods to compute various geometric properties and relationships of line segments.

This class is designed to be easily mutable (to the extent of having its contained points public). This supports a common pattern of reusing a single LineSegment object as a way of computing segment properties on the segments defined by arrays or lists of Coordinates.

TODO: have this class keep pointers rather then real Coordinates ?

## Member Function Documentation

double geos::geom::LineSegment::angle | ( | ) | const

Returns:
  the angle this segment makes with the x-axis (in radians)

void geos::geom::LineSegment::closestPoint | ( | const Coordinate & | p,
|  | Coordinate & | ret
| ) |  | const

Computes the closest point on this line segment to another point.

Parameters:

  p | the point to find the closest point to
  ret | the Coordinate to which the closest point on the line segment to the point p will be written

CoordinateSequence* geos::geom::LineSegment::closestPoints | ( | const LineSegment & | line ) |

Computes the closest points on two line segments.

Parameters:

  p | the point to find the closest point to

Returns:
  a pair of Coordinates which are the closest points on the line segments. The returned CoordinateSequence must be deleted by caller

int geos::geom::LineSegment::compareTo | ( | const LineSegment & | other ) | const

Compares this object with the specified object for order.

Uses the standard lexicographic ordering for the points in the LineSegment.

Parameters:

  o | the LineSegment with which this LineSegment is being compared

Returns:
  a negative integer, zero, or a positive integer as this LineSegment is less than, equal to, or greater than the specified LineSegment

bool geos::geom::LineSegment::equalsTopo | ( | const LineSegment & | other ) | const

Returns `true` if `other` is topologically equal to this LineSegment (e.g. irrespective of orientation).

Parameters:

  other | a `LineSegment` with which to do the comparison.

Returns:
  true if other is a LineSegment with the same values for the x and y ordinates.

bool geos::geom::LineSegment::intersection | ( | const LineSegment & | line,
|  | Coordinate & | coord
| ) |  | const

Computes an intersection point between two segments, if there is one. There may be 0, 1 or many intersection points between two segments. If there are 0, null is returned. If there is 1 or more, a single one is returned (chosen at the discretion of the algorithm). If more information is required about the details of the intersection, the LineIntersector class should be used.

Parameters:

  line |
  coord | the Coordinate to write the result into

Returns:
  true if an intersection was found, false otherwise

bool geos::geom::LineSegment::isHorizontal | ( | ) | const

Tests whether the segment is horizontal.

Returns:
  `true` if the segment is horizontal

bool geos::geom::LineSegment::isVertical | ( | ) | const

Tests whether the segment is vertical.

Returns:
  `true` if the segment is vertical

bool geos::geom::LineSegment::lineIntersection | ( | const LineSegment & | line,
|  | Coordinate & | coord
| ) |  | const

Computes the intersection point of the lines defined by two segments, if there is one.

There may be 0, 1 or an infinite number of intersection points between two lines. If there is a unique intersection point, it is returned. Otherwise, `null` is returned. If more information is required about the details of the intersection, the algorithms::LineIntersector class should be used.

Parameters:

  line | a line segment defining a straight line
  ret | will be set to the intersection point (if any)

Returns:
  true if an intersection was found, false otherwise

void geos::geom::LineSegment::midPoint | ( | Coordinate & | ret ) | const

Computes the midpoint of the segment.

Parameters:

  ret | will be set to the midpoint of the segment

void geos::geom::LineSegment::normalize | ( | ) |

Puts the line segment into a normalized form.

This is useful for using line segments in maps and indexes when topological equality rather than exact equality is desired.

int geos::geom::LineSegment::orientationIndex | ( | const LineSegment & | seg ) | const

Determines the orientation of a LineSegment relative to this segment. The concept of orientation is specified as follows: Given two line segments A and L, <ul A is to the left of a segment L if A lies wholly in the closed half-plane lying to the left of L A is to the right of a segment L if A lies wholly in the closed half-plane lying to the right of L otherwise, A has indeterminate orientation relative to L. This happens if A is collinear with L or if A crosses the line determined by L.

Parameters:

  seg | the LineSegment to compare

Returns:
  1 if seg is to the left of this segment
  -1 if seg is to the right of this segment
  0 if seg has indeterminate orientation relative to this segment

int geos::geom::LineSegment::orientationIndex | ( | const Coordinate & | p ) | const

Determines the orientation index of a Coordinate relative to this segment.

The orientation index is as defined in CGAlgorithms::computeOrientation.

Parameters:

  seg | the LineSegment to compare

Returns:
  1 if `p` is to the left of this segment
  -1 if `p` is to the right of this segment
  0 if `p` is collinear with this segment

See also:
  CGAlgorithms::computeOrientation(Coordinate, Coordinate, Coordinate)

void geos::geom::LineSegment::pointAlong | ( | double | segmentLengthFraction,
|  | Coordinate & | ret
| ) |  | const

Computes the Coordinate that lies a given fraction along the line defined by this segment.

A fraction of `0.0` returns the start point of the segment; a fraction of `1.0` returns the end point of the segment. If the fraction is < 0.0 or > 1.0 the point returned will lie before the start or beyond the end of the segment.

Parameters:

  segmentLengthFraction | the fraction of the segment length along the line
  ret | will be set to the point at that distance

void geos::geom::LineSegment::pointAlongOffset | ( | double | segmentLengthFraction,
|  | double | offsetDistance,
|  | Coordinate & | ret
| ) |  | const

Computes the Coordinate that lies a given fraction along the line defined by this segment and offset from the segment by a given distance.

A fraction of `0.0` offsets from the start point of the segment; a fraction of `1.0` offsets from the end point of the segment.

The computed point is offset to the left of the line if the offset distance is positive, to the right if negative.

Parameters:

  segmentLengthFraction | the fraction of the segment length along the line
  offsetDistance | the distance the point is offset from the segment (positive is to the left, negative is to the right)
  ret | will be set to the point at that distance and offset

void geos::geom::LineSegment::project | ( | const Coordinate & | p,
|  | Coordinate & | ret
| ) |  | const

Compute the projection of a point onto the line determined by this line segment.

Note that the projected point may lie outside the line segment. If this is the case, the projection factor will lie outside the range [0.0, 1.0].

bool geos::geom::LineSegment::project | ( | const LineSegment & | seg,
|  | LineSegment & | ret
| ) |  | const

Project a line segment onto this line segment and return the resulting line segment.

The returned line segment will be a subset of the target line line segment. This subset may be null, if the segments are oriented in such a way that there is no projection.

Note that the returned line may have zero length (i.e. the same endpoints). This can happen for instance if the lines are perpendicular to one another.

Parameters:

  seg | the line segment to project
  ret | the projected line segment

Returns:
  true if there is an overlap, false otherwise

double geos::geom::LineSegment::projectionFactor | ( | const Coordinate & | p ) | const

Compute the projection factor for the projection of the point p onto this LineSegment.

The projection factor is the constant r by which the vector for this segment must be multiplied to equal the vector for the projection of p on the line defined by this segment.

The projection factor returned will be in the range (-inf, +inf)

Parameters:

  p | the point to compute the factor for

Returns:
  the projection factor for the point

double geos::geom::LineSegment::segmentFraction | ( | const Coordinate & | inputPt ) | const

Computes the fraction of distance (in `[0.0, 1.0]`) that the projection of a point occurs along this line segment.

If the point is beyond either ends of the line segment, the closest fractional value (`0.0` or `1.0`) is returned.

Essentially, this is the projectionFactor clamped to the range `[0.0, 1.0]`.

Parameters:

  inputPt | the point

Returns:
  the fraction along the line segment the projection of the point occurs

std::auto_ptr<LineString> geos::geom::LineSegment::toGeometry | ( | const GeometryFactory & | gf ) | const

Creates a LineString with the same coordinates as this segment

Parameters:

  gf | the geometery factory to use

Returns:
  a LineString with the same geometry as this segment

The documentation for this class was generated from the following file:

- LineSegment.h